unsigned long temps0, temps1;  // Deux variables temps pour mesurer tau
float tau;  // Constante de temps (décimal)
int pinU = 2;  // Broche alimentant le circuit RC

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600) ;  // Initialisation de la communication série
  pinMode(pinU, OUTPUT);  // On définit la borne d'alimentation du circuit en Sortie
  digitalWrite(pinU, 0);  // On applique une tension nulle en entrée du circuit RC
}

void loop() {
  // put your main code here, to run repeatedly:
  digitalWrite(pinU, 0);
  Serial.println("Décharge du condensateur");
  Serial.println("Pressez l'interrupteur poussoir de court-circuit si décharge trop longue");
  while (analogRead(A0) > 0) {  // On s'assure que le condensateur se décharge
    Serial.println(analogRead(A0));  // On lit la tension aux bornes du condensateur (valeur entre 0 et 1023)
    delay(500);
  }
  Serial.println("La mesure va commencer dans 5 secondes");  // On va commencer la mesure
  Serial.println("Lachez l'interrupteur de court-circuit");
  delay(5000);
  Serial.println("Mesure en cours");
  temps0 = micros();  // On relève t0
  digitalWrite(pinU, 1);  // On applique 5V en entrée du circuit RC
  while (analogRead(A0) < 647) {  // Tant que le niveau lu est inférieur à 647 (63.2% de 1023)
    // on boucle sans rien faire
  }
  temps1 = micros();  // Une fois sorti de la boucle on mesure t1
  tau = (temps1 - temps0) * 1e-6;  // Calcul de tau, convertie en secondes
  Serial.print("Constante RC en s : ");
  Serial.println(tau, 3); // On affiche tau avec 3 chiffres après la virgule
  Serial.println("Nouvelle mesure dans 5 secondes");
  delay(5000);
}
